/************** BEST VIEWED IN A CODE EDITOR 80 COLUMNS WIDE *******************
*
* TSTAK/Versastack/ToughSystem 2.0 Labels
* Benjamen Johnson <workshop.electronsmith.com>
* 20201108
*
* openSCAD Version: 2019.05 
* Licesnse: Creative Commons - Attribution - Share Alike
*           https://creativecommons.org/licenses/by-sa/4.0/
*******************************************************************************/
/*[Hidden]*/
version = "V1_0";

TEXT=0;LABEL=1;

$dl = 0.01;

/*[Edit Me]*/
/*******************************************************************************
*
*******************************************************************************/
object = 0;//[0:Text,1:Label]
// What do you want the label to say?

// Enter the text you want to display
label = "SCREWDRIVERS";

// Print layer thickness
layer_thickness = 0.3;

// How big you want the text
font_size = 8;//[0:0.5:15]

/*[Font Options]*/
/*******************************************************************************
*
*******************************************************************************/
// Which font do you want to use
font = "Arial";

// How thick the font is (back to front)
font_thickness = layer_thickness;

/*[Base Dimensions]*/
/*******************************************************************************
*
*******************************************************************************/
base_width = 104;
base_height = 22;
base_thickness = 1;

BASE_DEF = [base_width,base_height,base_thickness];

/*[Text Box Dimensions]*/
/*******************************************************************************
*
*******************************************************************************/
text_box_width = 97;
text_box_height = 19;
text_box_thickness = 0; //[0:0.1:2]

TEXT_BOX_DEF = [text_box_width,text_box_height,text_box_thickness];

/*[Wall Dimensions]*/
/*******************************************************************************
*
*******************************************************************************/
top_wall_thickness = 2;
top_wall_height = 3.75;

TOP_WALL_DEF = [text_box_width, top_wall_thickness, top_wall_height];
TOP_WALL_POS = [0,(base_height-top_wall_thickness)/2,base_thickness+text_box_thickness+top_wall_height/2];

/*[Tab Dimensions]*/
/*******************************************************************************
*
*******************************************************************************/
tab_width = 4;
tab_thickness = 2;
tab_height = 6;

tab_distance = 37;

TAB_DEF = [tab_width,tab_thickness,tab_height];
LEFT_TAB_POS = [-tab_distance/2,base_height/2-top_wall_thickness-tab_thickness/2,base_thickness+text_box_thickness+tab_height/2];
RIGHT_TAB_POS = [tab_distance/2,base_height/2-top_wall_thickness-tab_thickness/2,base_thickness+text_box_thickness+tab_height/2];
TAB_CUTOUT_DEF = TOP_WALL_DEF;
TAB_CUTOUT_POS = [0,TOP_WALL_POS[1]-0.5,base_thickness+text_box_thickness+3*top_wall_height/2];

/*[Notch Dimensions]*/
/*******************************************************************************
*
*******************************************************************************/
notch_width = 20;
notch_distance = 0;

NOTCH_DEF = [notch_width, base_height-text_box_height+$dl, 10];
LEFT_NOTCH_POS = [-notch_distance/2,-text_box_height/2,0];
RIGHT_NOTCH_POS = [notch_distance/2,-text_box_height/2,0];

text_box_y_offset = (base_height-text_box_height)/2;

//registration points
POINT1 = [-(base_width/2+1),base_height/2+1,0];
POINT2 = -1 * POINT1;

/*******************************************************************************
* Do it
*******************************************************************************/
// registration points to alight the separate STL files
registration_point(POINT1);
registration_point(POINT2);

if(object == TEXT)
    color("white")
        make_text();

else 
    difference(){
        make_label();
        make_text();
}//end else
    
/*******************************************************************************
* Module for making the label
*******************************************************************************/
module make_label(){
    difference(){
        union(){
            translate([0,text_box_y_offset,text_box_thickness/2])
                cube(TEXT_BOX_DEF, center=true);
    
            translate([0,0,base_thickness/2+text_box_thickness])
                cube(BASE_DEF,center = true);
                
            translate(TOP_WALL_POS)
                cube(TOP_WALL_DEF,center=true);
                
            translate(LEFT_TAB_POS)
                cube(TAB_DEF,center=true);
                
            translate(RIGHT_TAB_POS)
                cube(TAB_DEF,center=true);
    
        } //end union
        
        translate(LEFT_NOTCH_POS)
            cube(NOTCH_DEF,center=true);
        
        translate(RIGHT_NOTCH_POS)
            cube(NOTCH_DEF,center=true);
        
        translate(TAB_CUTOUT_POS)
            cube(TAB_CUTOUT_DEF,center=true);
    } // end difference
} //end module

/*******************************************************************************
* Module for making the text
*******************************************************************************/
module make_text(){
        translate([0,text_box_y_offset,font_thickness-$dl]) 
        rotate([180,0,180])
        linear_extrude(height = font_thickness)
            text(text = label, font = font, size = font_size, valign="center",halign = "center");
}// end module

/*******************************************************************************
* Registration point module
*******************************************************************************/
module registration_point(P=[0,0,0]){
    translate(P)
    cylinder(d=0.1,h=layer_thickness);
}

